<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex1.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="../preface.html">Preface</a></li>
                <li><a href="../intro.html">The Hard Way Is Easier</a></li>
                <li><a href="../ex0.html">Ex0: The Setup</a></li>
                <li><a href="../ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="../ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="../ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="../ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="../ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="../ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="../ex7.html">Ex7: More Printing</a></li>
                <li><a href="../ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="../ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="../ex10.html">Ex10: What Was That?</a></li>
                <li><a href="../ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="../ex12.html">Ex12: Prompting People</a></li>
                <li><a href="../ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="../ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="../ex15.html">Ex15: Reading Files</a></li>
                <li><a href="../ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="../ex17.html">Ex17: More Files</a></li>
                <li><a href="../ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="../ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="../ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="../ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="../ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="../ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="../ex24.html">Ex24: More Practice</a></li>
                <li><a href="../ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="../ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="../ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="../ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="../ex29.html">Ex29: What If</a></li>
                <li><a href="../ex30.html">Ex30: Else And If</a></li>
                <li><a href="../ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="../ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="../ex33.html">Ex33: While Loops</a></li>
                <li><a href="../ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="../ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="../ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="../ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="../ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="../ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="../ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="../ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="../ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="../ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="../ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="../ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="../ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="../ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="../ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="../ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="../ex50.html">Ex50: Your First Website</a></li>
                <li><a href="../ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="../ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="../advice.html">Advice From An Old Programmer</a></li>
                <li><a href="../next.html">Next Steps</a></li>
                <li><a href="../appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex1.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex1.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex1.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 1: The Setup</h1>
                <p>In this appendix you will be instructed to do three things:</p>
<ul class="simple">
<li>Do some things in your shell (command line, Terminal, PowerShell).</li>
<li>Learn about what you just did.</li>
<li>Do more on your own.</li>
</ul>
<p>For this first exercise you'll be expected to get your Terminal open and working so that you can do the rest of the appendix.</p>
<div class="section" id="do-this">
<h1>Do This</h1>
<p>Get your Terminal, shell, or PowerShell working so you can access it quickly and know that it works.</p>
<div class="section" id="mac-osx">
<h2>Mac OSX</h2>
<p>For Mac OSX you'll need to do this:</p>
<ul class="simple">
<li>Hold down the <tt class="docutils literal">command</tt> key and hit the spacebar.</li>
<li>In the top right the blue &quot;search bar&quot; will pop up.</li>
<li>Type:  terminal</li>
<li>Click on the Terminal application that looks kind of like a black box.</li>
<li>This will open Terminal.</li>
<li>You can now go to your dock and CTRL-click to pull up the menu, then select <tt class="docutils literal"><span class="pre">Options-&gt;Keep</span></tt> In dock.</li>
</ul>
<p>Now you have your Terminal open and it's in your dock so you can get to it.</p>
</div>
<div class="section" id="linux">
<h2>Linux</h2>
<p>I'm assuming that if you have Linux then you already know how to get at your Terminal.  Look through the menu for your window manager for anything named &quot;Shell&quot; or &quot;Terminal.&quot;</p>
</div>
<div class="section" id="windows">
<h2>Windows</h2>
<p>On Windows we're going to use PowerShell. People used to work with a program called <tt class="docutils literal">cmd.exe</tt>, but it's not nearly as usable as PowerShell. If you have Windows 7 or later, do this:</p>
<ul class="simple">
<li>Click Start.</li>
<li>In &quot;Search programs and files&quot; type: powershell</li>
<li>Hit Enter.</li>
</ul>
<p>If you don't have Windows 7, you should <em>seriously</em> consider upgrading. If you still insist on not upgrading then you can try installing it from Microsoft's download center.  Search online to find &quot;powershell downloads&quot; for your version of Windows.  You are on your own, though, since I don't have Windows XP, but hopefully the PowerShell experience is the same.</p>
</div>
</div>
<div class="section" id="you-learned-this">
<h1>You Learned This</h1>
<p>You learned how to get your Terminal open so you can do the rest of this appendix.</p>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">If you have that really smart friend who already knows Linux, ignore him when he tells you to use something other than Bash.  I'm teaching you bash.  That's it.  He will claim that zsh will give you 30 more IQ points and win you millions in the stock market.  Ignore him.  Your goal is to get capable enough and at this level it doesn't matter which shell you use.  The next warning is stay off IRC or other places where &quot;hackers&quot; hang out.  They think it's funny to hand you commands that can destroy your computer.  The command <tt class="docutils literal">rm <span class="pre">-rf</span> /</tt> is a classic that you <em>must never type</em>.  Just avoid them.  If you need help, make sure you get it from someone you trust and not from random idiots on the internet.</p>
</div>
</div>
<div class="section" id="do-more">
<h1>Do More</h1>
<p>This exercise has a large &quot;do more&quot; part.  The other exercises are not as involved as this one, but I'm having you prime your brain for the rest of the appendix by doing some memorization.  Just trust me: this will make things silky smooth later on.</p>
<div class="section" id="linux-mac-osx">
<h2>Linux/Mac OSX</h2>
<p>Take this list of commands and create index cards with the names on the left on one side, and the definitions on the other side.  Drill them every day while continuing with the lessons in this appendix.</p>
<dl class="docutils">
<dt>pwd</dt>
<dd>print working directory</dd>
<dt>hostname</dt>
<dd>my computer's network name</dd>
<dt>mkdir</dt>
<dd>make directory</dd>
<dt>cd</dt>
<dd>change directory</dd>
<dt>ls</dt>
<dd>list directory</dd>
<dt>rmdir</dt>
<dd>remove directory</dd>
<dt>pushd</dt>
<dd>push directory</dd>
<dt>popd</dt>
<dd>pop directory</dd>
<dt>cp</dt>
<dd>copy a file or directory</dd>
<dt>mv</dt>
<dd>move a file or directory</dd>
<dt>less</dt>
<dd>page through a file</dd>
<dt>cat</dt>
<dd>print the whole file</dd>
<dt>xargs</dt>
<dd>execute arguments</dd>
<dt>find</dt>
<dd>find files</dd>
<dt>grep</dt>
<dd>find things inside files</dd>
<dt>man</dt>
<dd>read a manual page</dd>
<dt>apropos</dt>
<dd>find what man page is appropriate</dd>
<dt>env</dt>
<dd>look at your environment</dd>
<dt>echo</dt>
<dd>print some arguments</dd>
<dt>export</dt>
<dd>export/set a new environment variable</dd>
<dt>exit</dt>
<dd>exit the shell</dd>
<dt>sudo</dt>
<dd>DANGER! become super user root DANGER!</dd>
</dl>
</div>
<div class="section" id="id1">
<h2>Windows</h2>
<p>If you're using Windows then here's your list of commands:</p>
<dl class="docutils">
<dt>pwd</dt>
<dd>print working directory</dd>
<dt>hostname</dt>
<dd>my computer's network name</dd>
<dt>mkdir</dt>
<dd>make directory</dd>
<dt>cd</dt>
<dd>change directory</dd>
<dt>ls</dt>
<dd>list directory</dd>
<dt>rmdir</dt>
<dd>remove directory</dd>
<dt>pushd</dt>
<dd>push directory</dd>
<dt>popd</dt>
<dd>pop directory</dd>
<dt>cp</dt>
<dd>copy a file or directory</dd>
<dt>robocopy</dt>
<dd>robust copy</dd>
<dt>mv</dt>
<dd>move a file or directory</dd>
<dt>more</dt>
<dd>page through a file</dd>
<dt>type</dt>
<dd>print the whole file</dd>
<dt>forfiles</dt>
<dd>run a command on lots of files</dd>
<dt>dir -r</dt>
<dd>find files</dd>
<dt>select-string</dt>
<dd>find things inside files</dd>
<dt>help</dt>
<dd>read a manual page</dd>
<dt>helpctr</dt>
<dd>find what man page is appropriate</dd>
<dt>echo</dt>
<dd>print some arguments</dd>
<dt>set</dt>
<dd>export/set a new environment variable</dd>
<dt>exit</dt>
<dd>exit the shell</dd>
<dt>runas</dt>
<dd>DANGER! become super user root DANGER!</dd>
</dl>
<p>Drill, drill, drill! Drill until you can say these phrases right away when you see that word.  Then drill the inverse, so that you read the phrase and know what command will do that.  You're building your vocabulary by doing this, but don't spend so much time you go nuts and get bored.</p>
</div>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex1.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex1.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
